// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  class IAudioManager {
    public:
      /**
       * Construct a new IAudioManager.
       */
      IAudioManager();
      
      /**
       * Initializes the audio manager system.
       */
      virtual void init() = 0;

      /**
       * Ticks/Update the audio manager system.
       */
      virtual void update() = 0;

      /**
       * Deinitializes the audio manager system.
       */
      virtual ~IAudioManager();
  };
}