// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  class ITimeManager {
    public:
      float_t delta = 0.016f;
      float_t time = 0.016f;
    
      /**
       * Ticks / updates the time management system.
       */
      virtual void update() = 0;

      /**
       * Returns the real world time epoch.
       * 
       * @return Epoch time in milliseconds.
       */
      virtual int64_t getRealTime() = 0;

      /**
       * Cleans up the time manager.
       */
      virtual ~ITimeManager();
  };
}