// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "TimeoutEvent.hpp"

using namespace Dawn;

TimeoutEvent::TimeoutEvent() : CustomEvent() {
  internalData = 0.0f;
}

enum CustomEventResult TimeoutEvent::shouldEmit(const float_t &listener) {
  if(listener > internalData) return CustomEventResult::NOTHING;
  return CustomEventResult::INVOKE_AND_REMOVE;
}

float_t TimeoutEvent::transformData(const float_t &interval) {
  return interval;
}

void TimeoutEvent::tick(const float_t delta) {
  internalData += delta;
  emit();
}